//+------------------------------------------------------------------+
//|                                         PriceChannel_Stop_v1.mq4 |
//|                           Copyright  2005, TrendLaboratory Ltd. |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "E-mail: igorad2004@list.ru"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 Red

extern int ChannelPeriod = 9;
extern double Risk = 0.3;
extern int Signal = 1;
extern int Line = 1;
extern int Nbars = 1000;
extern string    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx =  "---------------------------------------------------------";
extern string    _="alert.wav";
extern bool      _?=false;
extern bool      ___?=false;
extern bool      ___?=false;
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];

int init() {
   SetIndexBuffer(0, g_ibuf_100);
   SetIndexBuffer(1, g_ibuf_104);
   SetIndexBuffer(2, g_ibuf_108);
   SetIndexBuffer(3, g_ibuf_112);
   SetIndexBuffer(4, g_ibuf_116);
   SetIndexBuffer(5, g_ibuf_120);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexArrow(0, 159);
   SetIndexArrow(1, 159);
   SetIndexArrow(2, 108);
   SetIndexArrow(3, 108);
   string ls_0 = "PriceChannel_Stop_v1(" + ChannelPeriod + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, "UpTrend Stop");
   SetIndexLabel(1, "DownTrend Stop");
   SetIndexLabel(2, "UpTrend Signal");
   SetIndexLabel(3, "DownTrend Signal");
   SetIndexLabel(4, "UpTrend Line");
   SetIndexLabel(5, "DownTrend Line");
   SetIndexDrawBegin(0, ChannelPeriod);
   SetIndexDrawBegin(1, ChannelPeriod);
   SetIndexDrawBegin(2, ChannelPeriod);
   SetIndexDrawBegin(3, ChannelPeriod);
   SetIndexDrawBegin(4, ChannelPeriod);
   SetIndexDrawBegin(5, ChannelPeriod);
   return (0);
}

int start() {
   int li_8;
   double ld_12;
   double ld_20;
   double ld_28;
   double lda_36[5000];
   double lda_40[5000];
   double lda_44[5000];
   double lda_48[5000];
   for (int li_4 = Nbars - 1; li_4 >= 0; li_4--) {
      g_ibuf_100[li_4] = EMPTY_VALUE;
      g_ibuf_104[li_4] = EMPTY_VALUE;
      g_ibuf_108[li_4] = EMPTY_VALUE;
      g_ibuf_112[li_4] = EMPTY_VALUE;
      g_ibuf_116[li_4] = EMPTY_VALUE;
      g_ibuf_120[li_4] = EMPTY_VALUE;
   }
   for (li_4 = Nbars - ChannelPeriod - 1; li_4 >= 0; li_4--) {
      ld_12 = High[li_4];
      ld_20 = Low[li_4];
      for (int li_0 = li_4 - 1 + ChannelPeriod; li_0 >= li_4; li_0--) {
         ld_28 = High[li_0];
         if (ld_12 < ld_28) ld_12 = ld_28;
         ld_28 = Low[li_0];
         if (ld_20 > ld_28) ld_20 = ld_28;
      }
      lda_36[li_4] = ld_12;
      lda_40[li_4] = ld_20;
      lda_44[li_4] = lda_36[li_4] - (lda_36[li_4] - lda_40[li_4]) * Risk;
      lda_48[li_4] = lda_40[li_4] + (lda_36[li_4] - lda_40[li_4]) * Risk;
      if (Close[li_4] > lda_44[li_4 + 1]) li_8 = 1;
      if (Close[li_4] < lda_48[li_4 + 1]) li_8 = -1;
      if (li_8 > 0 && lda_48[li_4] < lda_48[li_4 + 1]) lda_48[li_4] = lda_48[li_4 + 1];
      if (li_8 < 0 && lda_44[li_4] > lda_44[li_4 + 1]) lda_44[li_4] = lda_44[li_4 + 1];
      if (li_8 > 0) {
         
         
         if (Signal > 0 && g_ibuf_100[li_4 + 1] == -1.0) {
            g_ibuf_108[li_4] = lda_48[li_4];//
            
//if(___?==true){Alert(Symbol(),"--","-M",Period(),"    ==  BUY  !!!//");
//if(_?==true){PlaySound( _ );}}//  }
            
            
            
            if (Line > 0) g_ibuf_116[li_4] = lda_48[li_4];
         } else {
            g_ibuf_100[li_4] = lda_48[li_4];
            if (Line > 0) g_ibuf_116[li_4] = lda_48[li_4];
            g_ibuf_108[li_4] = -1;//


            
            
         }
         if (Signal == 2) g_ibuf_100[li_4] = 0;
         g_ibuf_104[li_4] = -1.0;
         g_ibuf_120[li_4] = EMPTY_VALUE;
      }
      if (li_8 < 0) {
         if (Signal > 0 && g_ibuf_104[li_4 + 1] == -1.0) {
            g_ibuf_112[li_4] = lda_44[li_4];//


            
            
            if (Line > 0) g_ibuf_120[li_4] = lda_44[li_4];
         } else {
            g_ibuf_104[li_4] = lda_44[li_4];
            if (Line > 0) g_ibuf_120[li_4] = lda_44[li_4];
            g_ibuf_112[li_4] = -1;//


            
            
         }
         if (Signal == 2) g_ibuf_104[li_4] = 0;
         g_ibuf_100[li_4] = -1.0;
         g_ibuf_116[li_4] = EMPTY_VALUE;
      }
   }
   if(g_ibuf_104[0]==-1){
     if(___?==true){Alert(Symbol(),"--","-M",Period(),"    ==  BUY  !!!");
     if(_?==true){PlaySound( _ );
                         }        }          }//  }}
   if(g_ibuf_112[0]==-1){
     if(___?==true){Alert(Symbol(),"--","-M",Period(),"     ==  SELL  !!! ");
     if(_?==true){PlaySound( _ );
     }}}//  }}
   return (0);
}